//---------------------------------------------------------------------------




#include <vcl.h>
#include "LTR34_STREAM.h"
#pragma hdrstop

#include "EXAMPLE_LTR34.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"

TLTR34_Stream_Thread  *STREAM_LTR34;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
//  RESET     ,  ,
//   ,      ,
//    34-,  , .
//---------------------------------------------------------------------------
void LTR_RESET(int LEVEL, TStrings *OUTT)
//LEVEL
// 
//       0 - 
//       1 -  
//       2 -  
//
//*OUTT -   "Lines"  MEMO,   .
//
//:
//      CRATES -  
//      NOM_CRATES- - 
//      SEL_CRATE - 
//      LTR_ONLINE
//      MODULES -   .
//      NOM_LTR511-  511
//      SEL_LTR511- 
//      LTR511_ONLINE
{
        int res,i;
        WORD MIDD[MODULE_MAX];
        // 
        if(LTR34_ONLINE)
        {
                res=LTR34_Close(&LTR34);
                OUTT->Add(" LTR34");
                LTR34_ONLINE=0;
        }
        if(LEVEL!=2)
        {
                // 
                if(LTR_ONLINE)
                {
                        res=LTR_Close(&LTR);
                        OUTT->Add("  LTR");
                        LTR_ONLINE=0;
                }
                if(LEVEL!=1)
                {
                        res=LTR_Init(&LTR);
                        res=LTR_Open(&LTR);
                        // 
                        OUTT->Add("  LTR");
                        res=LTR_GetCrates(&LTR,&CRATES[0][0]);
                        NOM_CRATES=0;
                        for(i=0;i<CRATE_MAX;i++)
                        if(CRATES[i][0]!=0)
                        {
                                NOM_CRATES++;
                        }
                        SEL_CRATE=0;//   .
                        res=LTR_Close(&LTR);
                }
                // 
                res=LTR_Init(&LTR);
                LTR.saddr=SADDR_DEFAULT;
                LTR.sport=SPORT_DEFAULT;
                memcpy(LTR.csn, CRATES[SEL_CRATE], SERIAL_NUMBER_SIZE);
                res=LTR_Open(&LTR);
                LTR_ONLINE=1;
                // 
                NOM_LTR34=0;
                OUTT->Add("  LTR34");
                res=LTR_GetCrateModules(&LTR,MIDD);
                for(i=0;i<MODULE_MAX;i++)
                if(MIDD[i]==MID_LTR34)
                {
                        MODULES[NOM_LTR34]=i+1;
                        NOM_LTR34++;
                }
                if(NOM_LTR34>0)SEL_LTR34=0;//
        }
        //  
        res=LTR34_Open(&LTR34,LTR.saddr,LTR.sport,CRATES[SEL_CRATE],MODULES[SEL_LTR34]);
        if(res==LTR_OK)
        {
                OUTT->Add("LTR34 !");
                LTR34_ONLINE=1;
                res=LTR34_TestEEPROM(&LTR34);
                if(res!=LTR_OK)
                {
                        OUTT->Add(" CRC  EEPROM!!!  "+IntToStr(res));
                }
                else
                {
                        OUTT->Add("CRC ,    ");

                       	res=LTR34_GetCalibrCoeffs(&LTR34);
                        if(res==LTR_OK)
                                OUTT->Add(" .");
                        else
                                OUTT->Add("  ");
                }
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RESET_ButtonClick(TObject *Sender)
{
        //    .
        LTR_RESET(0,Memo1->Lines);
        //  
        CRATE_Combo->Items->Clear();// 
        CRATE_Combo->Items->Clear();
        MODULE_Combo->Items->Clear();
        if(LTR_ONLINE)
        {
                for(int i=0;i<NOM_CRATES;i++)
                CRATE_Combo->Items->Add(CRATES[i]);
                CRATE_Combo->ItemIndex=SEL_CRATE;
        }
        if(LTR34_ONLINE)
        {
                for(int i=0;i<NOM_LTR34;i++)
                MODULE_Combo->Items->Add("SLOT "+IntToStr(MODULES[i]));
                MODULE_Combo->ItemIndex=SEL_LTR34;
                // 
                Panel2->Visible=true;
                STREAM_START->Enabled=true;
                STREAM_STOP->Enabled=false;
        }else
        {
                // 
                Panel2->Visible=false;
                STREAM_START->Enabled=true;
                STREAM_STOP->Enabled=false;
        }

}
//---------------------------------------------------------------------------
//   "RESET",     34  
void __fastcall TForm1::CRATE_ComboChange(TObject *Sender)
{

       //    .
       SEL_CRATE=CRATE_Combo->ItemIndex;
       //        .
       LTR_RESET(1,Memo1->Lines);
       //     34-,    34-.
       MODULE_Combo->Items->Clear();
       if(LTR34_ONLINE)
        {

                for(int i=0;i<NOM_LTR34;i++)
                MODULE_Combo->Items->Add("SLOT "+IntToStr(MODULES[i]));
                MODULE_Combo->ItemIndex=SEL_LTR34;
                // 
                Panel2->Visible=true;
                STREAM_START->Enabled=true;
                STREAM_STOP->Enabled=false;
        }else
        {
                // 
                Panel2->Visible=false;
                STREAM_START->Enabled=true;
                STREAM_STOP->Enabled=false;
        }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::MODULE_ComboChange(TObject *Sender)
{
       // 34- ,    .
       SEL_LTR34=MODULE_Combo->ItemIndex;
       //  .
       LTR_RESET(1,Memo1->Lines);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
        int i;
        Panel2->Visible=false;
        LTR34_TOTAL_CH=8;//    
        LTR34.FrequencyDivisor=FRQ_ID_SEL->Value;
        //  .
        Edit19->Text=FloatToStr(2000000/(64-LTR34.FrequencyDivisor))+" ";//
        //   .
        Edit20->Text=FloatToStr((2000000/(64-LTR34.FrequencyDivisor))/(LTR34_TOTAL_CH))+" ";//
        //  
        for(i=0;i<8;i++)
        {
                WORKS[i].StartValue=0;
                WORKS[i].StopValue=0;
                WORKS[i].ChangeSpeed=1000;
                WORKS[i].InWork=false;
                WORKS[i].MODE=false;
                WORKS[i].CH_ON=true;
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FRQ_ID_SELChange(TObject *Sender)
{
        LTR34.FrequencyDivisor=FRQ_ID_SEL->Value;
        //  .
        Edit19->Text=FloatToStr(2000000/(64-LTR34.FrequencyDivisor))+" ";//
        //   .
        Edit20->Text=FloatToStr((2000000/(64-LTR34.FrequencyDivisor))/(LTR34_TOTAL_CH))+" ";//
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CHON_1Click(TObject *Sender)
{
        LTR34_TOTAL_CH=0;
        // - .
        if(CHON_1->Checked)LTR34_TOTAL_CH++;
        if(CHON_2->Checked)LTR34_TOTAL_CH++;
        if(CHON_3->Checked)LTR34_TOTAL_CH++;
        if(CHON_4->Checked)LTR34_TOTAL_CH++;
        if(CHON_5->Checked)LTR34_TOTAL_CH++;
        if(CHON_6->Checked)LTR34_TOTAL_CH++;
        if(CHON_7->Checked)LTR34_TOTAL_CH++;
        if(CHON_8->Checked)LTR34_TOTAL_CH++;
        WORKS[0].CH_ON=CHON_1->Checked;
        WORKS[1].CH_ON=CHON_2->Checked;
        WORKS[2].CH_ON=CHON_3->Checked;
        WORKS[3].CH_ON=CHON_4->Checked;
        WORKS[4].CH_ON=CHON_5->Checked;
        WORKS[5].CH_ON=CHON_6->Checked;
        WORKS[6].CH_ON=CHON_7->Checked;
        WORKS[7].CH_ON=CHON_8->Checked;
        //   1,2,4,8 -   . , 
        //  ,       1,2,4,8  
        GEN_MODE_LED->ItemIndex=-1;
        STREAM_START->Enabled=false;
        if(LTR34_TOTAL_CH==1)
        {
                STREAM_START->Enabled=true;
                GEN_MODE_LED->ItemIndex=0;
        }
        if(LTR34_TOTAL_CH==2)
        {
                STREAM_START->Enabled=true;
                GEN_MODE_LED->ItemIndex=1;
        }
        if(LTR34_TOTAL_CH==4)
        {
                STREAM_START->Enabled=true;
                GEN_MODE_LED->ItemIndex=2;
        }
        if(LTR34_TOTAL_CH==8)
        {
                STREAM_START->Enabled=true;
                GEN_MODE_LED->ItemIndex=3;
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SET_CH1Click(TObject *Sender)
{
        float OLD;
        //   1- .
        WORKS[0].StartValue=WORKS[0].StopValue;//  .
        WORKS[0].StopValue=StrToFloat(Edit1->Text);
        WORKS[0].ChangeSpeed=StrToFloat(Edit2->Text)/((2000000/(64-LTR34.FrequencyDivisor))/(LTR34_TOTAL_CH));
        if(WORKS[0].StartValue>WORKS[0].StopValue)WORKS[0].ChangeSpeed=-WORKS[0].ChangeSpeed;
        if(WORKS[0].StartValue!=WORKS[0].StopValue)
        {
                WORKS[0].InWork=true;
                WORKS[0].MODE=OUT_SEL_1->ItemIndex;
                Memo1->Lines->Add(" 1:  "+FloatToStr(WORKS[0].StartValue)+"  "+ FloatToStr(WORKS[0].StopValue)+" C "+ FloatToStr(WORKS[0].ChangeSpeed) );
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SET_CH2Click(TObject *Sender)
{
        float OLD;
        //   2- .
        WORKS[1].StartValue=WORKS[1].StopValue;//  .
        WORKS[1].StopValue=StrToFloat(Edit3->Text);
        WORKS[1].ChangeSpeed=StrToFloat(Edit4->Text)/((2000000/(64-LTR34.FrequencyDivisor))/(LTR34_TOTAL_CH));
        if(WORKS[1].StartValue>WORKS[1].StopValue)WORKS[1].ChangeSpeed=-WORKS[1].ChangeSpeed;
        if(WORKS[1].StartValue!=WORKS[1].StopValue)
        {
                WORKS[1].InWork=true;
                WORKS[1].MODE=OUT_SEL_1->ItemIndex;
                Memo1->Lines->Add(" 2:  "+FloatToStr(WORKS[1].StartValue)+"  "+ FloatToStr(WORKS[1].StopValue)+" C "+ FloatToStr(WORKS[1].ChangeSpeed) );
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SET_CH3Click(TObject *Sender)
{
        float OLD;
        //   3- .
        WORKS[2].StartValue=WORKS[2].StopValue;//  .
        WORKS[2].StopValue=StrToFloat(Edit5->Text);
        WORKS[2].ChangeSpeed=StrToFloat(Edit6->Text)/((2000000/(64-LTR34.FrequencyDivisor))/(LTR34_TOTAL_CH));
        if(WORKS[2].StartValue>WORKS[2].StopValue)WORKS[2].ChangeSpeed=-WORKS[2].ChangeSpeed;
        if(WORKS[2].StartValue!=WORKS[2].StopValue)
        {
                WORKS[2].InWork=true;
                WORKS[2].MODE=OUT_SEL_1->ItemIndex;
                Memo1->Lines->Add(" 3:  "+FloatToStr(WORKS[2].StartValue)+"  "+ FloatToStr(WORKS[2].StopValue)+" C "+ FloatToStr(WORKS[2].ChangeSpeed) );
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SET_CH4Click(TObject *Sender)
{
        float OLD;
        //   4- .
        WORKS[3].StartValue=WORKS[3].StopValue;//  .
        WORKS[3].StopValue=StrToFloat(Edit7->Text);
        WORKS[3].ChangeSpeed=StrToFloat(Edit8->Text)/((2000000/(64-LTR34.FrequencyDivisor))/(LTR34_TOTAL_CH));
        if(WORKS[3].StartValue>WORKS[3].StopValue)WORKS[3].ChangeSpeed=-WORKS[3].ChangeSpeed;
        if(WORKS[3].StartValue!=WORKS[3].StopValue)
        {
                WORKS[3].InWork=true;
                WORKS[3].MODE=OUT_SEL_1->ItemIndex;
                Memo1->Lines->Add(" 4:  "+FloatToStr(WORKS[3].StartValue)+"  "+ FloatToStr(WORKS[3].StopValue)+" C "+ FloatToStr(WORKS[3].ChangeSpeed) );
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SET_CH5Click(TObject *Sender)
{
        float OLD;
        //   5- .
        WORKS[4].StartValue=WORKS[4].StopValue;//  .
        WORKS[4].StopValue=StrToFloat(Edit9->Text);
        WORKS[4].ChangeSpeed=StrToFloat(Edit10->Text)/((2000000/(64-LTR34.FrequencyDivisor))/(LTR34_TOTAL_CH));
        if(WORKS[4].StartValue>WORKS[4].StopValue)WORKS[4].ChangeSpeed=-WORKS[4].ChangeSpeed;
        if(WORKS[4].StartValue!=WORKS[4].StopValue)
        {
                WORKS[4].InWork=true;
                WORKS[4].MODE=OUT_SEL_1->ItemIndex;
                Memo1->Lines->Add(" 5:  "+FloatToStr(WORKS[4].StartValue)+"  "+ FloatToStr(WORKS[4].StopValue)+" C "+ FloatToStr(WORKS[4].ChangeSpeed) );
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SET_CH6Click(TObject *Sender)
{
        float OLD;
        //   6- .
        WORKS[5].StartValue=WORKS[5].StopValue;//  .
        WORKS[5].StopValue=StrToFloat(Edit11->Text);
        WORKS[5].ChangeSpeed=StrToFloat(Edit12->Text)/((2000000/(64-LTR34.FrequencyDivisor))/(LTR34_TOTAL_CH));
        if(WORKS[5].StartValue>WORKS[5].StopValue)WORKS[5].ChangeSpeed=-WORKS[5].ChangeSpeed;
        if(WORKS[5].StartValue!=WORKS[5].StopValue)
        {
                WORKS[5].InWork=true;
                WORKS[5].MODE=OUT_SEL_1->ItemIndex;
                Memo1->Lines->Add(" 6:  "+FloatToStr(WORKS[5].StartValue)+"  "+ FloatToStr(WORKS[5].StopValue)+" C "+ FloatToStr(WORKS[5].ChangeSpeed) );
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SET_CH7Click(TObject *Sender)
{
        float OLD;
        //   7- .
        WORKS[6].StartValue=WORKS[6].StopValue;//  .
        WORKS[6].StopValue=StrToFloat(Edit13->Text);
        WORKS[6].ChangeSpeed=StrToFloat(Edit14->Text)/((2000000/(64-LTR34.FrequencyDivisor))/(LTR34_TOTAL_CH));
        if(WORKS[6].StartValue>WORKS[6].StopValue)WORKS[6].ChangeSpeed=-WORKS[6].ChangeSpeed;
        if(WORKS[6].StartValue!=WORKS[6].StopValue)
        {
                WORKS[6].InWork=true;
                WORKS[6].MODE=OUT_SEL_1->ItemIndex;
                Memo1->Lines->Add(" 7:  "+FloatToStr(WORKS[6].StartValue)+"  "+ FloatToStr(WORKS[6].StopValue)+" C "+ FloatToStr(WORKS[6].ChangeSpeed) );
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SET_CH8Click(TObject *Sender)
{
        float OLD;
        //   8- .
        WORKS[7].StartValue=WORKS[7].StopValue;//  .
        WORKS[7].StopValue=StrToFloat(Edit15->Text);
        WORKS[7].ChangeSpeed=StrToFloat(Edit16->Text)/((2000000/(64-LTR34.FrequencyDivisor))/(LTR34_TOTAL_CH));
        if(WORKS[7].StartValue>WORKS[7].StopValue)WORKS[7].ChangeSpeed=-WORKS[7].ChangeSpeed;
        if(WORKS[7].StartValue!=WORKS[7].StopValue)
        {
                WORKS[7].InWork=true;
                WORKS[7].MODE=OUT_SEL_1->ItemIndex;
                Memo1->Lines->Add(" 8:  "+FloatToStr(WORKS[7].StartValue)+"  "+ FloatToStr(WORKS[7].StopValue)+" C "+ FloatToStr(WORKS[7].ChangeSpeed) );
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OUT_SEL_1Change(TObject *Sender)
{
        WORKS[0].MODE=OUT_SEL_1->ItemIndex;
        WORKS[1].MODE=OUT_SEL_2->ItemIndex;
        WORKS[2].MODE=OUT_SEL_3->ItemIndex;
        WORKS[3].MODE=OUT_SEL_4->ItemIndex;
        WORKS[4].MODE=OUT_SEL_5->ItemIndex;
        WORKS[5].MODE=OUT_SEL_6->ItemIndex;
        WORKS[6].MODE=OUT_SEL_7->ItemIndex;
        WORKS[7].MODE=OUT_SEL_8->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::STREAM_STARTClick(TObject *Sender)
{
        int i,j;
        int RES;
        //   
        j=0;
        for(i=0;i<8;i++)
        if(WORKS[i].CH_ON)//  
        {
                LTR34.LChTbl[j]=LTR34_CreateLChannel(i+1, WORKS[i].MODE);
                WORKS_ON[j]=i;//   
                j++;//   
        }
        LTR34.ChannelQnt=j;//   
        //  
        LTR34.FrequencyDivisor=FRQ_ID_SEL->Value;//   ,    .
        LTR34.UseClb=true;              // 
        LTR34.AcknowledgeType=true;     //   
        LTR34.ExternalStart=false;      //  
        LTR34.RingMode=false;           // 
        // .
        RES=LTR34_Reset(&LTR34);
        if(RES!=LTR_OK)
        {
                Memo1->Lines->Add(LTR34_GetErrorString(RES));
                Memo1->Lines->Add("   !  !");
                goto EXIT_START;
        }else
                Memo1->Lines->Add("  !!!");
        // 
        RES=LTR34_Config(&LTR34);
        if(RES!=LTR_OK)
        {
                Memo1->Lines->Add(LTR34_GetErrorString(RES));
                Memo1->Lines->Add("  !!  !");
                goto EXIT_START;
        }else
                Memo1->Lines->Add("  !!!");
        //  .
        //       
        LTR34_TOTAL_CH=0;
        // - .
        if(CHON_1->Checked)LTR34_TOTAL_CH++;
        if(CHON_2->Checked)LTR34_TOTAL_CH++;
        if(CHON_3->Checked)LTR34_TOTAL_CH++;
        if(CHON_4->Checked)LTR34_TOTAL_CH++;
        if(CHON_5->Checked)LTR34_TOTAL_CH++;
        if(CHON_6->Checked)LTR34_TOTAL_CH++;
        if(CHON_7->Checked)LTR34_TOTAL_CH++;
        if(CHON_8->Checked)LTR34_TOTAL_CH++;


        CHON_1->Enabled=false;
        CHON_2->Enabled=false;
        CHON_3->Enabled=false;
        CHON_4->Enabled=false;
        CHON_5->Enabled=false;
        CHON_6->Enabled=false;
        CHON_7->Enabled=false;
        CHON_8->Enabled=false;
        OUT_SEL_1->Enabled=false;
        OUT_SEL_2->Enabled=false;
        OUT_SEL_3->Enabled=false;
        OUT_SEL_4->Enabled=false;
        OUT_SEL_5->Enabled=false;
        OUT_SEL_6->Enabled=false;
        OUT_SEL_7->Enabled=false;
        OUT_SEL_8->Enabled=false;
        STREAM_START->Enabled=false;
        //   
        FRQ_ID_SEL->Enabled=false;
        //       
        //     .
        STREAM_STOP->Enabled=true;
        LTRSTREAM_GENERATE=false;
        LTR34STREAM_ON=true;
        STREAM_LTR34= new TLTR34_Stream_Thread(false);
      //  while(LTRSTREAM_GENERATE==false)Sleep(100);//  ,          LTRSTREAM_GENERATE  false;
EXIT_START:

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
        bool STATE[8]={false,false,false,false,false,false,false,false};//  
        int i;
        if(LTR34STREAM_ON==true)
                for(i=0;i<8;i++)
                        STATE[i]=!(WORKS[i].InWork);
        // 1
        Edit1->Enabled=STATE[0];
        Edit2->Enabled=STATE[0];
        SET_CH1->Enabled=STATE[0];
        // 2
        Edit3->Enabled=STATE[1];
        Edit4->Enabled=STATE[1];
        SET_CH2->Enabled=STATE[1];
        // 3
        Edit5->Enabled=STATE[2];
        Edit6->Enabled=STATE[2];
        SET_CH3->Enabled=STATE[2];
        // 4
        Edit7->Enabled=STATE[3];
        Edit8->Enabled=STATE[3];
        SET_CH4->Enabled=STATE[3];
        // 5
        Edit9->Enabled=STATE[4];
        Edit10->Enabled=STATE[4];
        SET_CH5->Enabled=STATE[4];
        // 6
        Edit11->Enabled=STATE[5];
        Edit12->Enabled=STATE[5];
        SET_CH6->Enabled=STATE[5];
        // 7
        Edit13->Enabled=STATE[6];
        Edit14->Enabled=STATE[6];
        SET_CH7->Enabled=STATE[6];
        // 8
        Edit15->Enabled=STATE[7];
        Edit16->Enabled=STATE[7];
        SET_CH8->Enabled=STATE[7];
        if(LTR34.BufferFull!=0)
                Panel5->Color=clRed;
        else
                Panel5->Color=clGreen;

        if(LTR34.BufferEmpty!=0)
                Panel4->Color=clRed;
        else
                Panel4->Color=clGreen;


}
//---------------------------------------------------------------------------

void __fastcall TForm1::STREAM_STOPClick(TObject *Sender)
{
        // 
        LTR34STREAM_ON=false;//  .
        while(LTRSTREAM_GENERATE==true)Sleep(100);//  ,          LTRSTREAM_GENERATE  false; 
        //    
        //      .
        STREAM_STOP->Enabled=false;
        LTR34STREAM_ON=false;
        STREAM_START->Enabled=true;
        FRQ_ID_SEL->Enabled=true;

        CHON_1->Enabled=true;
        CHON_2->Enabled=true;
        CHON_3->Enabled=true;
        CHON_4->Enabled=true;
        CHON_5->Enabled=true;
        CHON_6->Enabled=true;
        CHON_7->Enabled=true;
        CHON_8->Enabled=true;
        OUT_SEL_1->Enabled=true;
        OUT_SEL_2->Enabled=true;
        OUT_SEL_3->Enabled=true;
        OUT_SEL_4->Enabled=true;
        OUT_SEL_5->Enabled=true;
        OUT_SEL_6->Enabled=true;
        OUT_SEL_7->Enabled=true;
        OUT_SEL_8->Enabled=true;
}
//---------------------------------------------------------------------------




