//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

double VOLT_DATA[500000];//   
DWORD WORD_DATA[500000];//    
#include "LTR34_STREAM.h"
#pragma package(smart_init)

TChannel_Work WORKS[8];    //     .
int  WORKS_ON[8];    //  

char    CRATES[CRATE_MAX][SERIAL_NUMBER_SIZE];// -   
int     NOM_CRATES;             //- - 
int     SEL_CRATE;              // - 
int     LTR_ONLINE;
int     MODULES[MODULE_MAX];    // -     .
int     NOM_LTR34;              //-  511
int     SEL_LTR34;              //-   
int     LTR34_ONLINE;
int     LTR34_TOTAL_CH;         //   
TLTR34 LTR34;
TLTR    LTR;

bool LTR34STREAM_ON=false;   //      
bool LTRSTREAM_GENERATE;     //  ,   .




//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TLTR34_Stream_Thread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall TLTR34_Stream_Thread::TLTR34_Stream_Thread(bool CreateSuspended)
        : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall TLTR34_Stream_Thread::Execute()
{
        int i,j,c;
        int RES;
        int size;
        float D;
        //   ,  ,  .
        size=(2000000/(64-LTR34.FrequencyDivisor))/(LTR34_TOTAL_CH);
        //   ,   0V,         -.
        FreeOnTerminate = true; //        
        j=0;
        for(i=0;i<size;i++)
                for(c=0;c<LTR34_TOTAL_CH;c++)
                {
                        VOLT_DATA[j]=WORKS[WORKS_ON[c]].StartValue/1000;//
                        j++;
                }
        //   
        RES=LTR34_ProcessData(&LTR34, VOLT_DATA, WORD_DATA, j, true);
        if(RES<0)goto ERROR_STOP;
        //  ,  FIFO
        RES=LTR34_Send(&LTR34, WORD_DATA,j,2000);// 2 ,       
        if(RES<0)goto ERROR_STOP;
        //  ,  FIFO
        RES=LTR34_Send(&LTR34, WORD_DATA,j,2000);// 2 ,       
        if(RES<0)goto ERROR_STOP;
        //  .
        RES=LTR34_DACStart(&LTR34);
        if(RES<0)goto ERROR_STOP;
        //  -  
        while(LTR34STREAM_ON==true)//    
        {
                LTRSTREAM_GENERATE=true;
                // 
                RES=LTR_Recv(&LTR34.Channel,WORD_DATA, NULL , size*LTR34_TOTAL_CH, 10000);// ,    .
                if(RES<0)goto ERROR_STOP;
                Sleep(900);

                //   ,   
                j=0;
                for(i=0;i<size;i++)
                        for(c=0;c<LTR34_TOTAL_CH;c++)
                        {
                                VOLT_DATA[j]=WORKS[WORKS_ON[c]].StartValue/1000;//
                                if(WORKS[WORKS_ON[c]].InWork==true)
                                {
                                        WORKS[WORKS_ON[c]].StartValue+=WORKS[WORKS_ON[c]].ChangeSpeed;
                                        if(WORKS[WORKS_ON[c]].ChangeSpeed<0)
                                        {
                                               if(WORKS[WORKS_ON[c]].StartValue<WORKS[WORKS_ON[c]].StopValue)
                                               WORKS[WORKS_ON[c]].InWork=false;
                                        }
                                        else
                                        {
                                               if(WORKS[WORKS_ON[c]].StartValue>WORKS[WORKS_ON[c]].StopValue)
                                               WORKS[WORKS_ON[c]].InWork=false;
                                        }
                                }
                                j++;
                        }
                RES=LTR34_ProcessData(&LTR34, VOLT_DATA, WORD_DATA, j, true);
                if(RES<0)goto ERROR_STOP;
                //  ,  FIFO
                RES=LTR34_Send(&LTR34, WORD_DATA,j,2000);// 2 ,       
                if(RES<0)goto ERROR_STOP;
        }
ERROR_STOP:
        // .
        RES=LTR34_DACStop(&LTR34);
        LTRSTREAM_GENERATE=false;//  
}
        //---------------------------------------------------------------------------
